#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#define DIRECTINPUT_VERSION 0x0300
#include <dinput.h>

// those files will get modified for newer versions of ZiNc
#include "game_defines.h"
#include "controller_defines.h"


typedef struct
{
    unsigned char key;
    unsigned long bit;
} ipc_keystate;

typedef struct
{
	int				count;
	ipc_keystate	player1[16];
	ipc_keystate	player2[16];
	ipc_keystate	player3[16];
	ipc_keystate	player4[16];
} ipc_keystates_t;

ipc_keystates_t s11_pad_states =
{
	16,
	{	// player 1 keys
		{DIK_RIGHT, 8},
		{DIK_LEFT, 9},
		{DIK_DOWN, 10},
		{DIK_UP, 11},
		{DIK_R, 0},
		{DIK_Q, 1},
		{DIK_W, 2},
		{DIK_E, 3},
		{DIK_F, 4},
		{DIK_Z, 5},
		{DIK_X, 6},
		{DIK_C, 7},
		{DIK_A, 12},
		{DIK_S, 13},
		{DIK_D, 14},
		{DIK_1, 15},		// start
	},
	{	// player 2 keys
		{DIK_U, 8},
		{DIK_U, 9},
		{DIK_U, 10},
		{DIK_U, 11},
		{DIK_U, 0},
		{DIK_U, 1},
		{DIK_U, 2},
		{DIK_U, 3},
		{DIK_U, 4},
		{DIK_U, 5},
		{DIK_U, 6},
		{DIK_U, 7},
		{DIK_U, 12},
		{DIK_U, 13},
		{DIK_U, 14},
		{DIK_2, 15},		// start
	},
	{	// player 3 keys
		{DIK_I, 8},
		{DIK_I, 9},
		{DIK_I, 10},
		{DIK_I, 11},
		{DIK_I, 0},
		{DIK_I, 1},
		{DIK_I, 2},
		{DIK_I, 3},
		{DIK_I, 4},
		{DIK_I, 5},
		{DIK_I, 6},
		{DIK_I, 7},
		{DIK_Z, 12},		// tekken 2 kick1
		{DIK_X, 13},		// tekken 2 kick2, souledge block
		{DIK_I, 14},
		{DIK_3, 15},		// start
	},
	{	// player 4 keys
		{DIK_O, 8},
		{DIK_O, 9},
		{DIK_O, 10},
		{DIK_O, 11},
		{DIK_O, 0},
		{DIK_O, 1},
		{DIK_O, 2},
		{DIK_O, 3},
		{DIK_O, 4},
		{DIK_O, 5},
		{DIK_O, 6},
		{DIK_O, 7},
		{DIK_O, 12},
		{DIK_O, 13},
		{DIK_O, 14},
		{DIK_4, 15},		// start
	},

};

ipc_keystates_t kn1_pad_states =
{
	7,
	{
		{DIK_RIGHT, 3},
		{DIK_LEFT, 2},
		{DIK_DOWN, 1},
		{DIK_UP, 0},
		{DIK_A, 4},
		{DIK_S, 5},
		{DIK_1, 8},
	},
	{
		{DIK_M, 3},
		{DIK_B, 2},
		{DIK_N, 1},
		{DIK_H, 0},
		{DIK_J, 4},
		{DIK_K, 5},
		{DIK_2, 8},
	}
};

ipc_keystates_t zn1_pad_states =
{
	11,
	{
		{DIK_RIGHT, 3},
		{DIK_LEFT, 2},
		{DIK_DOWN, 1},
		{DIK_UP, 0},
		{DIK_A, 4},
		{DIK_S, 5},
		{DIK_D, 6},
	    {DIK_1, 8},  
		{DIK_Z, 12},
		{DIK_X, 13},
		{DIK_C, 14},
	},
	{
		{DIK_M, 3},
		{DIK_B, 2},
		{DIK_N, 1},
		{DIK_H, 0},
		{DIK_J, 4},
		{DIK_K, 5},
		{DIK_L, 6},
	    {DIK_2, 8}, 
		{DIK_U, 12},
		{DIK_I, 13},
		{DIK_O, 14},
	}
};

ipc_keystates_t rz_pad_states =
{
	8,
	{
		{DIK_RIGHT, 3},
		{DIK_LEFT, 2},
		{DIK_DOWN, 1},
		{DIK_UP, 0},
		{DIK_A, 4},
		{DIK_S, 5},
		{DIK_D, 6},
	    {DIK_1, 8},  
	},
	{
		{DIK_M, 3},
		{DIK_B, 2},
		{DIK_N, 1},
		{DIK_H, 0},
		{DIK_J, 4},
		{DIK_K, 5},
		{DIK_L, 6},
	    {DIK_2, 8},  
	}

};

ipc_keystates_t null_pad_states =
{
	0
};

ipc_keystates_t *j_pad_states;



ipc_keystate j_coinslot_states[] =
{
    {DIK_5, JAMMA_CTRL_COIN1},		// coin for player 1
    {DIK_6, JAMMA_CTRL_COIN2},		// coin for player 2
    {0x41,	JAMMA_CTRL_TEST},		// test switch
    {0x42,	JAMMA_CTRL_SERVICE},	// service switch
};





BYTE keys[256];
IDirectInput       *lpDI;
IDirectInputDevice *lpDID;

long CALLBACK ZN_JammaClose(void)
{
	if (lpDID != NULL)
	{
		lpDID->Unacquire();
		lpDID->Release();
		lpDID = NULL;
	}

	if (lpDI != NULL)
	{
		lpDI->Release();
		lpDI=NULL;
	}
	return 0;
}


long CALLBACK ZN_JammaOpen(HWND hwnd, vendor_id_t vendor_id, game_id_t game_id, char *cfg_file_name)
{
	HRESULT res;


	switch(vendor_id)
	{
	case MACHINE_NAMCO_S11:
		j_pad_states = &s11_pad_states;
		break;
	case MACHINE_CAPCOM_ZN1:
	case MACHINE_TAITO_FX1A:
	case MACHINE_TAITO_FX1A2:
		j_pad_states = &zn1_pad_states;
		break;
	case MACHINE_BANPRESTO_KN1:
		j_pad_states = &kn1_pad_states;
		break;
	case MACHINE_RAIZING_ZN:
		j_pad_states = &rz_pad_states;
		break;
	case MACHINE_UNKNOWN:
	default:
		printf("ERROR: System not yet emulated\n");
		j_pad_states = &null_pad_states;
		break;
	}


	lpDI = NULL;
	lpDID = NULL;

	if((res = DirectInputCreate(AfxGetInstanceHandle(), DIRECTINPUT_VERSION, &lpDI, NULL))!=DI_OK)
	{
		switch(res)
		{
		case	DIERR_BETADIRECTINPUTVERSION:
				printf("ERROR: DirectInput DIERR_BETADIRECTINPUTVERSION\n");
				break;
		case	DIERR_INVALIDPARAM:
				printf("ERROR: DirectInput DIERR_INVALIDPARAM\n");
				break;
		case	DIERR_OLDDIRECTINPUTVERSION:
				printf("ERROR: DirectInput DIERR_OLDDIRECTINPUTVERSION\n");
				break;
		case	DIERR_OUTOFMEMORY:
				printf("ERROR: DirectInput DIERR_OUTOFMEMORY\n");
				break;
		default:
				printf("ERROR: unknown DirectInputCreate Error!\n");
				break;
		}
		ZN_JammaClose();
		return -1;
	}

	res = lpDI->CreateDevice(GUID_SysKeyboard, &lpDID, NULL);
	if (res != DI_OK)
	{
		printf("ERROR: DirectInput: Create Device Failed");
		ZN_JammaClose();
		return -1;
	}

	res = lpDID->SetDataFormat(&c_dfDIKeyboard);
	if (res != DI_OK)
	{
		printf("ERROR: DirectInput:Set Data Format failed\n");
		ZN_JammaClose();
		return -1;
	}

	res = lpDID->SetCooperativeLevel(hwnd, DISCL_NONEXCLUSIVE | DISCL_BACKGROUND);

	if (res != DI_OK)
	{
		printf("ERROR: DirectInput:SetCooperative Level Failed\n");
		ZN_JammaClose();
		return -1;
	}

	res = lpDID->Acquire();
	if (res != DI_OK)
	{
		printf("ERROR: DirectInput: Acquire Failed\n");
		ZN_JammaClose();
		return -1;
	}

	printf("JAMMA keyboard driver 0.2 initialized\n");
	return 0;
}







unsigned long CALLBACK ZN_JammaRead(jamma_t *jamma)
{
	HRESULT res;
	unsigned short i;
	
	// grab keyboard state into array
	do
	{
		res = lpDID->GetDeviceState(256, &keys);
		if (res == DIERR_INPUTLOST) lpDID->Acquire();
	}
	while (res == DIERR_INPUTLOST);

	if (res != DI_OK)
		return -1;

    jamma->controls = 0;
    for (i=0;i<4;i++)
        if (keys[j_coinslot_states[i].key] &0x80)
            jamma->controls |= j_coinslot_states[i].bit;

    jamma->players[0] = jamma->players[1] = jamma->players[2] = jamma->players[3] = 0;
    for (i=0;i<j_pad_states->count;i++)
	{
        if (keys[j_pad_states->player1[i].key] &0x80)
		{
			jamma->players[0] |= 1 << j_pad_states->player1[i].bit;
		}
        if (keys[j_pad_states->player2[i].key] &0x80)
		{
			jamma->players[1] |= 1 << j_pad_states->player2[i].bit;
		}
        if (keys[j_pad_states->player3[i].key] &0x80)
		{
			jamma->players[2] |= 1 << j_pad_states->player3[i].bit;
		}
        if (keys[j_pad_states->player4[i].key] &0x80)
		{
			jamma->players[3] |= 1 << j_pad_states->player4[i].bit;
		}
	}

	// for now players 2,3 and 4 are unemulated
//	

	return 0;
}



